// Build.h
//
//////////////////////////////////////////////////////////////////
#ifndef BUILD_H
#define BUILD_H
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
/* Last Modified: 2003.01.10 */
#include <math.h>
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
SDL_Color BLACK = {0,0,0, 0};
SDL_Color LIGHTGRAY = {  196,196,196, 0 };
SDL_Color GRAY = {128,128,128, 0};
SDL_Color DARKGRAY = {64,64,64, 0};
SDL_Color RED = {255,0,0, 0};
SDL_Color BLUE = {0,0,255, 0};
SDL_Color DARKGREEN = {0,128,0, 0};
SDL_Color GREEN = {0,255,0, 0};
SDL_Color YELLOW = {255,255,0, 0};
SDL_Color PURPLE = {255,0,255, 0};
SDL_Color ORANGE = {128,128,0, 0};
SDL_Color WHITE = {255,255,255, 0};

#ifndef _WINDOWS_
SDL_Color TRANSPARENT = {164,192,234, 0};
#else
SDL_Color CLR_TRANSPARENT = {164,192,234, 0};
#endif

const int SECONDS = 1000;

SDL_Rect RCEMPTY = {0,0,0,0};
//////////////////////////////////////////////////////////////////
SDL_Rect newSDL_Rect( int xs,int ys, int dx,int dy ) {
	SDL_Rect rc = { xs,ys, dx,dy };
	return( rc );
}
bool IsIn( SDL_Rect &a, SDL_Rect &b ) {
	return( a.x >= b.x && a.y >= b.y && a.x+a.w <= b.x+b.w && a.y+a.h <= b.y+b.h );
}
bool IsIn2( SDL_Rect &a, SDL_Rect &b ) {
	return( a.x >= b.x && a.y >= b.y && a.w <= b.w && a.h <= b.h );
}
bool IsIn2( SDL_Rect &a, SDL_Rect &b, int dx,int dy ) {
/* This guy doesn't really work yet, but it should return okay if
   "a" is within += dx/dy units of "b" */
	if( ( a.x >= b.x && a.y >= b.y && a.w <= b.w && a.h <= b.h ) ||
		( a.x >= b.x-dx && a.y >= b.y && a.w <= b.w+dx && a.h <= b.h ) ||
		//( a.x >= b.x && a.y >= b.y && a.w <= b.w+dx && a.h <= b.h ) ||
		( a.x >= b.x && a.y >= b.y-dy && a.w <= b.w && a.h <= b.h+dy ) ){//||
		//( a.x >= b.x && a.y >= b.y && a.w <= b.w && a.h <= b.h+dy ) ) {
		return( true );
	}
	return( false );
}
/*
	*-----*          *------*       *-------*   *----*       *--*
	|     |  *---*   |    *-+---*   | *---* |   |    |     *-+  +-*
	|     |  |   |   |    |     |   | |   | |   |  *-+-*   | |  | |
	|     |  *---*   |    *-+---*   | *---* |   *--+   |   *-+  +-*
	*-----*          *------*       *-------*      *---*     *--*
	*/
bool RectAtouchesB( SDL_Rect &a, SDL_Rect &b ) {
	if ( (a.y > (b.y+b.h)) ||
		 (a.x > (b.x+b.w)) ||
	     (b.y > (a.y+a.h)) ||
	     (b.x > (a.x+a.w)) ) {
		return(false);
	}
	return(true);//*/
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
/* The following will get the overlap of two rectangles:*/
SDL_Rect GetOverlap( SDL_Rect &a, SDL_Rect &b ) {
	SDL_Rect rcOverlap;
	if( b.y+b.h < a.y ||
		a.y+a.h < b.y ||
		b.x+b.w < a.x ||
		a.x+a.w < b.x ) {
		rcOverlap = newSDL_Rect( -1,-1,0,0 );
	} else {
		rcOverlap.x = (a.x < b.x)?b.x:a.x;
		rcOverlap.y = (a.y < b.y)?b.y:a.y;
		int x2 = (a.x < b.x)?a.x+a.w:b.x+b.w;
		int y2 = (a.y < b.y)?a.y+a.h:b.y+b.h;
		rcOverlap.w = x2-rcOverlap.x;
		rcOverlap.h = y2-rcOverlap.y;
	}
	return(rcOverlap);

}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
SDL_Color newSDL_Color( int r, int g, int b, int a ) {
	SDL_Color clr = { r,g,b, a };
	return( clr );
}
SDL_Color newSDL_Color( int r, int g, int b ) {
	SDL_Color clr = { r,g,b, SDL_ALPHA_OPAQUE };
	return( clr );
}
bool operator==(SDL_Color a, SDL_Color b) {
	return( a.r == b.r && a.g == b.g && a.b == b.b );
}
bool operator!=(SDL_Color a, SDL_Color b) {
	return( ( a.r != b.r || a.g != b.g || a.b != b.b ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
#define SDL_CreateRGBSurface_Screen( flags, w,h ) \
	SDL_CreateRGBSurface( (flags), (w),(h), (SDL_GetVideoSurface()->format->BitsPerPixel), (SDL_GetVideoSurface()->format->Rmask), (SDL_GetVideoSurface()->format->Gmask), (SDL_GetVideoSurface()->format->Bmask), (SDL_GetVideoSurface()->format->Amask) )
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
int SDL_MapRGB( SDL_PixelFormat *format, SDL_Color clr ) {
	return( SDL_MapRGB( format, clr.r, clr.g, clr.b ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
int SDL_FillRect( SDL_Surface *dest, SDL_Rect *rc, SDL_Color &clr ) {
	if( dest == NULL ) {  return(-1);  }
	return( SDL_FillRect( dest, rc, SDL_MapRGB( dest->format, clr.r,clr.g,clr.b ) ) );
}
int SDL_FillRectA( SDL_Surface *dest, SDL_Rect *rc, SDL_Color &clr ) {
	if( dest == NULL ) {  return(-1);  }
	return( SDL_FillRect( dest, rc, SDL_MapRGBA( dest->format, clr.r,clr.g,clr.b,clr.unused ) ) );
}
//////////////////////////////////////////////////////////////////
int SDL_SetColorKey( SDL_Surface *dest, int flags, SDL_Color &clr ) {
	return( SDL_SetColorKey( dest,flags,SDL_MapRGB(dest->format,clr.r,clr.g,clr.b) ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
double log( double b, double x ) {
	return( log10(x)/log10(b) );
}
//////////////////////////////////////////////////////////////////
double Dist( double x1,double y1, double x2,double y2 ) {
	return( sqrt( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
SDL_Surface* CloneBitmap( SDL_Surface* b ) {
	if( b == NULL ) {  return(NULL);  }
	return( SDL_ConvertSurface(b, b->format, b->flags) );



	/*// For this to work, we need to use clean bitmaps (no colorkey, no alpha, etc.)
	// Get the alpha & clear it:
	Uint8 a = b->format->alpha;
	SDL_SetAlpha( b, SDL_SRCALPHA, SDL_ALPHA_OPAQUE ); //255
	// Get the Colorkey & clear it:
	Uint32 clrkey = b->format->colorkey;
	SDL_SetColorKey( b, SDL_SRCCOLORKEY, 0 );

	//SDL_Surface* bmpBmp = SDL_CreateRGBSurface(SDL_SWSURFACE, b->w,b->h, b->format->BitsPerPixel, b->format->Rmask,b->format->Gmask,b->format->Bmask,b->format->Amask );
	SDL_Surface* bmpBmp = SDL_CreateRGBSurface(SDL_SWSURFACE, b->w,b->h, b->format->BitsPerPixel, 0,0,0,0 );
	SDL_BlitSurface( b,NULL, bmpBmp,&(SDL_Rect)newSDL_Rect(0,0, 0,0) );
	SDL_SetColorKey( bmpBmp, SDL_SRCCOLORKEY, clrkey );
	SDL_SetAlpha( bmpBmp, SDL_SRCALPHA, a );

	// Fix up the original:
	SDL_SetAlpha( b, SDL_SRCALPHA, a );
	SDL_SetColorKey( b, SDL_SRCCOLORKEY, clrkey );

	return( bmpBmp );//*/
	
	//SDL_Surface *sReturn;
	/*sReturn = SDL_CreateRGBSurface( SDL_SRCALPHA|SDL_SRCCOLORKEY|SDL_SWSURFACE,
									b->w,b->h,
									b->format->BitsPerPixel,
									b->format->Rmask,
									b->format->Gmask,
									b->format->Bmask,
									b->format->Amask );
	SDL_FillRect( sReturn,NULL, b->format->colorkey );
	SDL_SetColorKey( sReturn, SDL_SRCCOLORKEY, b->format->colorkey );
	SDL_SetAlpha( sReturn, SDL_SRCALPHA, b->format->alpha );
	SDL_BlitSurface( b,NULL, sReturn,&(SDL_Rect)newSDL_Rect(0,0, 0,0) );*/

	//sReturn = SDL_ConvertSurface( b,b->format,b->flags );

	//sReturn = SDL_CreateRGBSurface(SDL_SWSURFACE, b->w,b->h, b->format->BitsPerPixel, 0,0,0,0 );
	//SDL_BlitSurface( b,NULL, sReturn,&(SDL_Rect)newSDL_Rect(0,0, 0,0) );

	//return( sReturn );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
/* Draw a rectangle (unfilled) with a width of 'line'. */
void DrawRect( SDL_Surface *dest, int x,int y, int w,int h, int line, SDL_Color &clr ) {
	SDL_Rect rc = { x,y, w,line };
		SDL_FillRect( dest,&rc,clr );
	rc = newSDL_Rect( x,y+h-line, w,line );
		SDL_FillRect( dest,&rc,clr );
	rc = newSDL_Rect( x,y+line, line,h-2*line );
		SDL_FillRect( dest,&rc,clr );
	rc = newSDL_Rect( x+w-line,y+line, line,h-2*line );
		SDL_FillRect( dest,&rc,clr );
}
void DrawRect( SDL_Surface *dest, int x,int y, int w,int h, SDL_Color &clr ) {
	DrawRect( dest, x,y, w,h, 1, clr );
};
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
#endif
//////////////////////////////////////////////////////////////////