// WaitFrame.h | by Doug Manley (from Sam)
///////////////////////////////////////////////////////////////////
#ifndef WAITFRAME_H
#define WAITFRAME_H
///////////////////////////////////////////////////////////////////
//#define WAITFRAME_ERROR10
//#define WAITFRAME_OUT
//#define WAITFRAME_GETFPS
///////////////////////////////////////////////////////////////////
Uint32 FPS = 32;
int WaitFrame_actualFPS = 0;
Uint32 WaitFrame_ticks = 0;
///////////////////////////////////////////////////////////////////
void SetWaitFrameFPS( Uint32 fps ) {
	FPS = fps;
	WaitFrame_actualFPS = FPS;
}
#define WaitFrame_SetFPS( x ) SetWaitFrameFPS( x )
///////////////////////////////////////////////////////////////////
Uint32 WaitFrame_GetFPS() {  return(FPS);  };
///////////////////////////////////////////////////////////////////
// From Sam:
void WaitFrame( void ) {
	static Uint32 next_tick = 0;
	static Uint32 this_tick = 0;

	Uint32 last_tick = this_tick;

	// Wait for the next frame
	this_tick = SDL_GetTicks();
	if ( this_tick < next_tick ) {
#ifdef WAITFRAME_ERROR10
#ifdef WAITFRAME_OUT
		printf("WaitFrame(): Time to spare: %i.\n",((next_tick-this_tick)/10)*10 );
#endif
		SDL_Delay( Uint32((next_tick-this_tick)/10)*10 );
#else
#ifdef WAITFRAME_OUT
		printf("WaitFrame(): Time to spare: %i.\n",(next_tick-this_tick) );
#endif
		SDL_Delay( (next_tick-this_tick) );
#endif
	}
#ifdef WAITFRAME_OUT
	else if( this_tick > next_tick ) {
		printf("This tick: %8i... should be: %8i  |  FPS: %i\n",this_tick,next_tick,1000/(1000/FPS+this_tick-next_tick));
	}
#endif

#ifdef WAITFRAME_GETFPS
	if( this_tick > next_tick ) {
		WaitFrame_actualFPS = Uint32( double(FPS)/double(double(this_tick-last_tick)/(1000.0/FPS)) );
	} else {
		WaitFrame_actualFPS = FPS;
	}
#endif

	this_tick = SDL_GetTicks();

#ifdef WAITFRAME_ERROR10
	next_tick = this_tick + ((1000/FPS)/10)*10;
#else
	next_tick = this_tick + (1000/FPS);
#endif

	WaitFrame_ticks++;
#ifdef WAITFRAME_OUT
	printf("*** TICK %i ***\n",WaitFrame_ticks );
#endif
}
///////////////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////////////
